/**
 * WPPA slideshow block
 *
 * Version: 8.2.02.004
 */

jQuery(document).ready(function(){
( function ( blocks, editor, i18n, element, components, _, blockEditor ) {

	var el = element.createElement;
	var RichText = blockEditor.RichText;
	var CheckboxControl = blockEditor.CheckboxControl;
	var useBlockProps = blockEditor.useBlockProps;
	var wppaSlideshowAlbumList = wppaAlbumList.slice();
		wppaSlideshowAlbumList[0] = { label: wppaTextLastAlbumAdded, value: "0" };

	blocks.registerBlockType( 'wp-photo-album-plus/slideshow', {
		title: wppaTextSlideshow,
		icon: el( 'img', {
							src: 	wppaImageDirectory+'camera32.png',
							style: 	{ width: '24px', height: '24px' },
						} ),
		category: 'layout',

		attributes: {
			widgetTitle: {
				type: 'string',
				selector: 'h2',
			},
			wppaAlbum: {
				type: 'number',
				value: 0,
			},
			wppaShortcode: {
				type: 'string',
				value: '[wppa type="slideonly" album="#last"]',
			},
			filmstrip: {
				type: 'boolean',
				checked: false,
			},
			cacheIt: {
				type: 'boolean',
				checked: false,
			}
		},

		example: {
			attributes: {
				widgetTitle: 'Photo of the day',
				wppaAlbum: 0,
				wppaShortcode: '[wppa type="slideonly" album="#last"]',
				filmstrip: false,
				cacheIt: false,
			},
		},

		edit: function( props ) {
			var blockProps = wp.blockEditor.useBlockProps();
			var attributes = props.attributes;

			return el(
				'div',
				blockProps,
				el('h2',null,wppaTextSimpleSlideshow),
				wppaOnWidgets() ?
				el( RichText, {
					tagName: 'h3',
					placeholder: wppaTextEnterWidgetCaption,
					value: attributes.widgetTitle,
					onChange: function ( value ) {
						props.setAttributes( { widgetTitle: value } );
					},
				}) : null,
				el(
					wp.components.SelectControl,
					{
						label: wppaTextSelectAlbum,
						value: attributes.wppaAlbum,
						options: wppaSlideshowAlbumList,
						onChange: function( val ) {
							props.setAttributes( { wppaAlbum: parseInt(val) } );
							props.setAttributes( { wppaShortcode: evaluate(props) } );
						},
					}
				),
				el( wp.components.CheckboxControl, {
					label: wppaTextAddFilmstrip,
					checked: attributes.filmstrip,
					onChange: function( value ) {
						props.setAttributes( { filmstrip: value } );
					},
				}),
				el( wp.components.CheckboxControl, {
					label: wppaTextCacheThisBlock,
					help: wppaTextCacheUsesSmart,
					checked: attributes.cacheIt,
					onChange: function ( value ) {
						props.setAttributes( { cacheIt: value } );
					},
				}),
				el('small',null,wppaTextCorrShortcode+': '+evaluate(props)),
			);
		},

		save: function( props ) {
			var attributes = props.attributes;
			return el(
				'div',
				{},
				el('h3',{},attributes.widgetTitle),
				el('div',{},evaluate(props)),
			);
		},
	} );

	function evaluate( props ) {
		var attributes = props.attributes;
		var shortcode;

		if ( attributes.filmstrip ) {
			shortcode = '[wppa type="slideonlyf"';
		}
		else {
			shortcode = '[wppa type="slideonly"';
		}

		if ( parseInt(attributes.wppaAlbum) > 0 ) {
			shortcode += ' album="'+attributes.wppaAlbum+'"';
		}
		else {
			shortcode += ' album="#last"';
		}

		if ( attributes.cacheIt ) {
			shortcode += ' cache="inf"';
		}

		if ( wppaOnWidgets() ) {
			shortcode += ' widget="slide"';
		}
		shortcode += ']';

		return shortcode;
	}
} )(
	window.wp.blocks,
	window.wp.editor,
	window.wp.i18n,
	window.wp.element,
	window.wp.components,
	window._,
	window.wp.blockEditor
)});
