<?php
/* wppa-admin-local-js.php
* Package: wp-photo-album-plus
*
* local js code for admin pages
* Version 8.3.03.003
*
*/

function wppa_add_local_js( $slug ) {

	switch( $slug ) {

		case 'wppa_album_photos':
			{
				$the_js = "
				function wppaTryMove( id, video ) {

					var query;

					if ( ! jQuery( '#target-' + id ).val() ) {
						alert( '" . esc_js( __( 'Please select an album to move to first.', 'wp-photo-album-plus' ) ) . "' );
						return false;
					}

					if ( video ) {
						query = '" . esc_js( __( 'Are you sure you want to move this video?', 'wp-photo-album-plus' ) ) . "';
					}
					else {
						query = '" . esc_js( __( 'Are you sure you want to move this photo?', 'wp-photo-album-plus' ) ) . "';
					}

					if ( confirm( query ) ) {
						wppaAjaxUpdatePhoto( id, 'moveto', document.getElementById( 'target-' + id ).value );
					}
				}

				function wppaTryCopy( id, video ) {

					var query;

					if ( ! jQuery( '#target-' + id ).val() ) {
						alert( '" . esc_js( __( 'Please select an album to copy to first.', 'wp-photo-album-plus' ) ) . "' );
						return false;
					}

					if ( video ) {
						query = '" . esc_js( __( 'Are you sure you want to copy this video?', 'wp-photo-album-plus' ) ) . "';
					}
					else {
						query = '" . esc_js( __( 'Are you sure you want to copy this photo?', 'wp-photo-album-plus' ) ) . "';
					}

					if ( confirm( query ) ) {
						wppaAjaxUpdatePhoto( id, 'copyto', document.getElementById( 'target-' + id ).value );
					}
				}

				function wppaTryDelete( id, video, perm ) {

					var query;

					if ( perm ) {
						if ( video ) {
							query = '" . esc_js( __( 'Are you sure you want to remove this video permanently?', 'wp-photo-album-plus' ) ) . "';
						}
						else {
							query = '" . esc_js( __( 'Are you sure you want to remove this photo permanently?', 'wp-photo-album-plus' ) ) . "';
						}
					}
					else {
						if ( video ) {
							query = '" . esc_js( __( 'Are you sure you want to delete this video?', 'wp-photo-album-plus' ) ) . "';
						}
						else {
							query = '" . esc_js( __( 'Are you sure you want to delete this photo?', 'wp-photo-album-plus' ) ) . "';
						}
					}

					if ( confirm( query ) ) {
						if ( perm ) {
							wppaAjaxDeletePhoto( id, '', '', true );
						}
						else {
							wppaAjaxDeletePhoto( id );
						}
						jQuery( window ).trigger( 'scroll' );
					}
				}

				function wppaTryUndelete ( id ) {
					wppaAjaxUndeletePhoto( id );
				}

				function wppaTryRotLeft( id ) {

					var query = '" . esc_js( __( 'Are you sure you want to rotate this photo left?', 'wp-photo-album-plus' ) ) . "';

					if ( confirm( query ) ) {
						wppaAjaxUpdatePhoto( id, 'rotleft', 0 );
					}
				}

				function wppaTryRot180( id ) {

					var query = '" . esc_js( __( 'Are you sure you want to rotate this photo 180&deg;?', 'wp-photo-album-plus' ) ) . "';

					if ( confirm( query ) ) {
						wppaAjaxUpdatePhoto( id, 'rot180', 0 );
					}
				}

				function wppaTryRotRight( id ) {

					var query = '" . esc_js( __( 'Are you sure you want to rotate this photo right?', 'wp-photo-album-plus' ) ) .  "';

					if ( confirm( query ) ) {
						wppaAjaxUpdatePhoto( id, 'rotright', 0 );
					}
				}

				function wppaTryFlip( id ) {

					var query = '" . esc_js( __( 'Are you sure you want to flip this photo?', 'wp-photo-album-plus' ) ) . "';

					if ( confirm( query ) ) {
						wppaAjaxUpdatePhoto( id, 'flip', 0 );
					}
				}

				function wppaTryFlop( id ) {

					var query = '" . esc_js( __( 'Are you sure you want to flip this photo?', 'wp-photo-album-plus' ) ) . "';

					if ( confirm( query ) ) {
						wppaAjaxUpdatePhoto( id, 'flop', 0 );
					}
				}

				function wppaTryWatermark( id, hasSource, canRemove ) {

					var query;
					var wmFile = jQuery( '#wmfsel_' + id ).val();
					if ( wmFile == '--- none ---' ) {
						alert( '" . esc_js( __( 'No watermark selected', 'wp-photo-album-plus' ) ) . "' );
						return;
					}
					if ( hasSource ) {
						query = '" . esc_js( __( 'Are you sure?', 'wp-photo-album-plus' ) ) . "';
						query += '. ';
						query += '" . esc_js( __( 'To revert to the default watermark setting afterwards: select Watermark: --- default --- and press the Remake files button', 'wp-photo-album-plus' ) ) . "';
						if ( canRemove ) {
							query += '. ';
							query += '" . esc_js( __( 'To remove: select Watermark: --- none --- and press the Remake files button', 'wp-photo-album-plus' ) ) . "';
						}
					}
					else {
						query = '" . esc_js( __( 'Are you sure? Once applied it can not be removed!', 'wp-photo-album-plus' ) ) . "';
						query += '. ';
						query += '" . esc_js( __( 'And I do not know if there is already a watermark on this photo', 'wp-photo-album-plus' ) ) . "';
					}

					if ( confirm( query ) ) {
						wppaAjaxApplyWatermark( id, document.getElementById( 'wmfsel_' + id ).value, document.getElementById( 'wmpsel_' + id ).value );
					}
				}

				function wppaTryMagick( id, slug, value ) {

					if ( ! value ) {
						value = 0;
					}

					var query = '" . esc_js( __( 'Are you sure you want to magically process this photo?', 'wp-photo-album-plus' ) ) .  "';

					if ( true || confirm( query ) ) {
						jQuery( '#wppa-admin-spinner' ).css( 'display', 'inline' );
						wppaAjaxUpdatePhoto( id, slug, value );
					}
				}

				wppaHor = false;
				function wppaToggleHorizon() {
					if ( wppaHor ) {
						jQuery( '#wppa-horizon' ).css( 'display', 'none' );
						wppaHor = false;
					}
					else {
						jQuery( '#wppa-horizon' ).css( 'display', 'inline' );
						wppaHor = true;
					}
				}

				function wppaTryScheduledel( id ) {
					wppaPhotoStatusChange( id );
					if ( ! jQuery( '#scheduledel-' + id ).prop( 'checked' ) ) {
						wppaAjaxUpdatePhoto( id, 'removescheduledel', 0 );
					}
				}
				";

				// The script for the tabs to operate
				$the_js .= '
				function wppaChangePhotoAdminTab(elm,tabId,itemId) {
					jQuery(".wppa-photoadmin-tab-"+itemId).removeClass(\'active\');
					jQuery(elm).addClass(\'active\');
					jQuery(".wppa-tabcontent-"+itemId).hide();
					jQuery(tabId).show();
				}';
			}
			break;

		case 'wppa_album_photos_bulk':
			{
				$the_js = "
				function wppaTryMove( id, video ) {

					var query;

					if ( ! jQuery( '#target-' + id ).val() ) {
						alert( '" . esc_js( __( 'Please select an album to move to first.', 'wp-photo-album-plus' ) ) . "' );
						return false;
					}

					if ( video ) {
						query = '" . esc_js( __( 'Are you sure you want to move this video?', 'wp-photo-album-plus' ) ) . "';
					}
					else {
						query = '" . esc_js( __( 'Are you sure you want to move this photo?', 'wp-photo-album-plus' ) ) . "';
					}

					if ( ! jQuery('#confirm-move').prop('checked') || confirm( query ) ) {
						jQuery( '#moving-' + id ).html( '". __( 'Moving...', 'wp-photo-album-plus' ) . "' );
						wppaAjaxUpdatePhoto( id, 'moveto', jQuery( '#target-' + id ).val(), false, '<td colspan=\'8\' >', '</td>' );
					}
				}" . '
				jQuery(document).ready( function() {
					wppaSetConfirmDelete( "confirm-delete" );
					wppaSetConfirmMove( "confirm-move" );
				});
				function wppaConfirmAndDelete(id, immediate) {
					if ( ! jQuery("#confirm-delete").prop("checked") ||
						 confirm( "' . esc_js( __( 'Are you sure you want to delete this photo?', 'wp-photo-album-plus' ) ) . '" ) ) {
							jQuery("#wppa-delete-"+id).html( "' . esc_js( __('Deleting...', 'wp-photo-album-plus' ) ) . '" );
							wppaAjaxDeletePhoto(id, "<td colspan=8 >", "</td>", immediate);
					}
				}';
			}
			break;

		case 'wppa_album_photos_sequence':
			{
				$the_js = '
				jQuery( function() {
					jQuery( "#sortable" ).sortable( {
						cursor: "move",
						placeholder: "sortable-placeholder-photos",
						stop: function( e, ui ) {
							var ids = jQuery( ".wppa-sort-item" );
							var seq = jQuery( ".wppa-sort-seqn" );
							var idx = 0;
							while ( idx < ids.length ) {
								var newvalue;
								if ( wppaSeqnoDesc ) {
									newvalue = ids.length - idx;
								}
								else newvalue = idx + 1;
								var oldvalue = seq[idx].value;
								var photo = ids[idx].value;
								if ( newvalue != oldvalue ) {
									wppaDoSeqUpdate( photo, newvalue );
								}
								idx++;
							}
						},
						delay: 		100,
						opacity: 	0.5,
						scroll: 	false,
						cursorAt: 	{ left: 90, top: 90 }
					});
					jQuery( "#sortable" ).disableSelection();
				});
				var wppaAjaxRequests = 0;
				function wppaDoSeqUpdate( photo, seqno ) {
					if ( wppaAjaxRequests >=10 ) {
						setTimeout(function(){wppaDoSeqUpdate( photo, seqno );},500);
						return;
					}
					var data = "action=wppa&wppa-action=update-photo&photo-id="+photo+"&item=p_order&wppa-nonce="+document.getElementById(\'photo-nonce-\'+photo).value+"&value="+seqno;
					var xmlhttp = new XMLHttpRequest();

					xmlhttp.onreadystatechange = function() {
						if ( xmlhttp.readyState == 4 && xmlhttp.status != 404 ) {
							var ArrValues = xmlhttp.responseText.split( "||" );
							if ( ArrValues[0] != "" ) {
								alert("The server returned unexpected output:\n"+ArrValues[0]);
							}
							switch ( ArrValues[1] ) {
								case "0":	// No error
									jQuery("#wppa-seqno-"+photo).html(seqno);
									break;
								case "99":	// Photo is gone
									jQuery("#wppa-seqno-"+photo).html(\'<span style="color:red">deleted</span>\');
									break;
								default:	// Any error
									jQuery("#wppa-seqno-"+photo).html(\'<span style="color:red">Err:"+ArrValues[1]+"</span>\');
									break;
							}
							wppaAjaxRequests--;
							wppaConsoleLog("Pending ajax requests = "+wppaAjaxRequests);
						}
					}
					xmlhttp.open("POST",wppaAjaxUrl,true);
					xmlhttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");
					xmlhttp.send( data );
					wppaAjaxRequests++;
					wppaConsoleLog("Pending ajax requests = "+wppaAjaxRequests);
					jQuery("#wppa-sort-seqn-"+photo).val(seqno);	// set hidden value to new value to prevent duplicate action
					var spinnerhtml = \'<img src="\'+wppaImageDirectory+\'spinner.gif" />\';
					jQuery("#wppa-seqno-"+photo).html(spinnerhtml);
				}';
			}
			break;

		case '_wppa_admin':
			{
				$the_js = '
				function wppaChangeAlbumAdminTab(elm,tabid) {
					jQuery(".wppa-albumadmin-tab").removeClass(\'active\');
					jQuery(elm).addClass(\'active\');
					jQuery(".wppa-tabcontent").hide();
					jQuery(tabid).show();
				}
				function wppaGoEditAlbNo() {
					var id = parseInt(document.getElementById("wppa-edit-albid").value);
					if (id > 0) {
						var nonce = "' . wp_create_nonce( 'wppa-nonce' ) .'";
						var href = "' . get_admin_url() . 'admin.php?page=wppa_admin_menu&wppa-nonce="+nonce+"&tab=edit&edit-id="+id;
						document.location.href=href;
					}
					else {
						alert("' . __( 'Please enter a valid album id', 'wp-photo-album-plus' ) . '");
					}
				}
				function wppaGoApplyFilter() {
					var filter = document.getElementById("wppa-edit-filter").value;
					if(filter) {
						document.location.href="' . get_admin_url() . 'admin.php?page=wppa_admin_menu&switchto=flat&filter="+filter;
					}
					else {
						alert("' . __( 'Please select a filter token', 'wp-photo-album-plus' ) . '");
					}
				}
				function wppaTryInheritCats( id ) {

					var query = "' . esc_js( __( 'Are you sure you want to inherit categories to all (sub-)sub albums of this album?', 'wp-photo-album-plus' ) ) . '";
					if ( confirm( query ) ) {
						wppaAjaxUpdateAlbum( id, \'inherit_cats\', Math.random() );
					}
				}
				function wppaTryAddCats( id ) {

					var query = "' . esc_js( __( 'Are you sure you want to add the categories to all (sub-)sub albums of this album?', 'wp-photo-album-plus' ) ) . '";
					if ( confirm( query ) ) {
						wppaAjaxUpdateAlbum( id, \'inhadd_cats\', Math.random() );
					}
				}
				function wppaTryApplyDeftags( id ) {

					var query = "' . esc_js( __( 'Are you sure you want to set the default tags to all photos in this album?', 'wp-photo-album-plus' ) ) . '";
					if ( confirm( query ) ) {
						wppaAjaxUpdateAlbum( id, \'set_deftags\', Math.random(), true );
					}
				}
				function wppaTryAddDeftags( id ) {

					var query = "' . esc_js( __( 'Are you sure you want to add the default tags to all photos in this album?', 'wp-photo-album-plus' ) ) . '";
					if ( confirm( query ) ) {
						wppaAjaxUpdateAlbum( id, \'add_deftags\', Math.random(), true );
					}
				}
				function wppaTryScheduleAll( id ) {

					var query;
					if ( ! jQuery( "#schedule-box" ).prop( "checked" ) ) {
						query = "' . esc_js( __( 'Please switch feature on and set date/time to schedule first', 'wp-photo-album-plus' ) ) . '";
						alert( query );
						return;
					}
					query = "' . esc_js( __( 'Are you sure you want to schedule all photos in this album?', 'wp-photo-album-plus' ) ) . '";
					if ( confirm( query ) ) {
						wppaAjaxUpdateAlbum( id, \'setallscheduled\', Math.random(), true );
					}
				}
				function wppaTryScheduledelAlb( id ) {

					wppaAjaxUpdateAlbum( id, "scheduledel", Math.random() );
					if ( ! jQuery( "#scheduledel" ).prop( "checked" ) ) {
						wppaAjaxUpdateAlbum( id, "removescheduledel", 0 );
					}
				}
				function wppaTrySetAllPanorama( id ) {
					var panoval = jQuery( "#pano-opt" ).val();
					if ( panoval == 0 || panoval == 1 || panoval == 2 ) {
						var url = "' . get_admin_url() . 'admin.php?page=wppa_admin_menu&tab=edit&edit-id="+id+"&wppa-nonce=' . wp_create_nonce( 'wppa-nonce' ) . '&pano-val="+panoval;
						document.location = url;
					}
					else {
						alert("' . __( 'Please select a valid panorama mode', 'wp-photo-album-plus' ) . '");
					}
				}
				function wppaGetCoverPreview( albumId, divId ) {

					jQuery.ajax( {

						url: 		wppaAjaxUrl,
						data: 		"action=wppa" +
									"&wppa-action=getshortcodedrendered" +
									"&shortcode=[wppa type=\"cover\" album=\""+albumId+"\"]",
						async: 		true,
						type: 		"GET",
						timeout: 	10000,
						beforeSend: function( xhr ) {
									},
						success: 	function( result, status, xhr ) {
										result = result.replace(/\[script/g, "<script");
										result = result.replace(/\[\/script/g, "</script");
										result = result.replace(/&gt;/g, ">");
										jQuery( "#" + divId ).html( result );
									},
						error: 		function( xhr, status, error ) {
										wppaConsoleLog( "wppaGetCoverPreview failed. Error = " + error + ", status = " + status );
									},
						complete: 	function( xhr, status, newurl ) {

									}
					} );
				}';
			}
			break;

		case 'wppa_album_sequence':
			{
				$the_js = '
				jQuery( function() {
					jQuery( "#sortable-albums" ).sortable( {
						cursor: 		"move",
						placeholder: 	"sortable-placeholder-albums",
						stop: 			function( e, ui ) { wppaDoRenumber(); },
						axis: 			"y",
						delay: 			100,
						opacity:		0.5,
						scroll: 		false,
						cursorAt: 		{ top: 30 }
					} );
				} );
				var wppaRenumberPending = false;
				var wppaAjaxInProgress 	= 0;

				function wppaDoRenumber() {
					if ( wppaAjaxInProgress > 0 ) {
						wppaRenumberPending = true;
					}
					else {
						_wppaDoRenumber();
					}
				}

				function _wppaDoRenumber() {

					// Init
					var ids = jQuery( ".wppa-sort-item-albums" );
					var seq = jQuery( ".wppa-sort-seqn-albums" );
					var descend = wppaAlbSeqnoDesc;

					// Mark needs update
					var idx = 0;
					while ( idx < ids.length ) {
						var newvalue;
						if ( descend ) newvalue = ids.length - idx;
						else newvalue = idx + 1;
						var oldvalue = seq[idx].value;
						var album = ids[idx].value;
						if ( newvalue != oldvalue ) {
							jQuery( "#wppa-pb-"+idx ).css({backgroundColor:"orange"});
						}
						idx++;
					}

					// Process
					var idx = 0;
					while ( idx < ids.length ) {
						var newvalue;
						if ( descend ) newvalue = ids.length - idx;
						else newvalue = idx + 1;
						var oldvalue = seq[idx].value;
						var album = ids[idx].value;
						if ( newvalue != oldvalue ) {
							wppaDoSeqUpdateAlbum( album, newvalue );
							jQuery( "#wppa-pb-"+idx ).css({backgroundColor:"yellow"});
							wppaLastAlbum = album;
						}
						idx++;
					}
				}

				var wppaAjaxRequests = 0;
				function wppaDoSeqUpdateAlbum( album, seqno ) {
					if ( wppaAjaxRequests >=10 ) {
						setTimeout(function(){wppaDoSeqUpdateAlbum( album, seqno );},500);
						return;
					}
					var data = 	"action=wppa" +
								"&wppa-action=update-album" +
								"&album-id=" + album +
								"&item=a_order" +
								"&wppa-nonce=" + document.getElementById( "album-nonce-" + album ).value +
								"&value=" + seqno;
					var xmlhttp = new XMLHttpRequest();

					xmlhttp.onreadystatechange = function() {
						if ( xmlhttp.readyState == 4 && xmlhttp.status != 404 ) {
							var ArrValues = xmlhttp.responseText.split( "||" );
							if ( ArrValues[0] != "" ) {
								alert( "The server returned unexpected output:\n" + ArrValues[0] );
							}
							switch ( ArrValues[1] ) {
								case "0":	// No error
									var i = seqno - 1;
									var descend = wppaAlbSeqnoDesc;
									if ( descend ) {
										i = wppaAlbumCount - seqno;
									}
									jQuery( "#wppa-album-seqno-" + album ).html( seqno );
									if ( wppaRenumberPending ) {
										jQuery( "#wppa-pb-"+i ).css({backgroundColor:"orange"});
									}
									else {
										jQuery( "#wppa-pb-"+i ).css({backgroundColor:"green"});
									}
									if ( wppaLastAlbum = album ) {
										wppaRenumberBusy = false;
									}
									break;
								default:	// Any error
									jQuery( "#wppa-album-seqno-" + album ).html( "<span style=\'color:red\' >Err:" + ArrValues[1] + "</span>" );
									break;
							}
							wppaAjaxRequests--;
							wppaConsoleLog("Pending ajax requests = "+wppaAjaxRequests);

							wppaAjaxInProgress--;

							// No longer busy?
							if ( wppaAjaxInProgress == 0 ) {

								if ( wppaRenumberPending ) {

									// Redo
									wppaRenumberPending = false;
									wppaDoRenumber();
								}
							}
						}
					};
					xmlhttp.open( "POST",wppaAjaxUrl,true );
					xmlhttp.setRequestHeader( "Content-type","application/x-www-form-urlencoded" );
					xmlhttp.send( data );
					wppaAjaxRequests++;
					wppaConsoleLog("Pending ajax requests = "+wppaAjaxRequests);
					wppaAjaxInProgress++;

					jQuery( "#wppa-sort-seqn-albums-" + album ).prop( "value", seqno );
					var spinnerhtml = "<img src=\'" + wppaImageDirectory + "spinner.gif\' />";
					jQuery( "#wppa-album-seqno-" + album ).html( spinnerhtml );
				}';
			}
			break;

		case 'wppa_ajax_import_upload':
			{
				$the_js = '
				function wppaGetUploadOptions() {

					var options = {
						beforeSend: function() {
							jQuery("#progress").show();
							jQuery("#bar").width("0%");
							jQuery("#message").html("");
							jQuery("#percent").html("");
						},
						uploadProgress: function(event, position, total, percentComplete) {
							jQuery("#bar").css("backgroundColor","#7F7");
							jQuery("#bar").width(percentComplete+"%");
							jQuery("#percent").html(percentComplete+"%");
						},
						success: function() {
							jQuery("#bar").width("100%");
							jQuery("#percent").html(wppaDone);
							jQuery("#wppa-upload-display").val("' . __( 'Browse...', 'wp-photo-album-plus' ) . '");
						},
						complete: function(response) {
							var success = response.responseText.substr(0,1);
							if ( success == "0" ) {
								jQuery("#message").html( "<span style=\"color: red;\" >"+wppaServerError+"</span>" );
								jQuery("#bar").css("backgroundColor","#F77");
								jQuery("#percent").html(wppaUploadFailed);
							}
							jQuery("#message").html( "<span>"+response.responseText.substr(1)+"</span>" );
						},
						error: function() {
							jQuery("#message").html( "<span style=\"color: red;\" >"+wppaServerError+"</span>" );
							jQuery("#bar").css("backgroundColor","#F77");
							jQuery("#percent").html(wppaUploadFailed);
						}
					};

					return options;
				}
				function wppaDisplaySelectedFilesForImport(id) {
					var theFiles = jQuery("#"+id);
					var i = 0;
					var result = "";
					var ok = true;
					var maxlen = parseInt("' . ini_get( 'upload_max_filesize' ) . '") * 1024 * 1024;
					var maxfiles = ' . ini_get( 'max_file_uploads' ) . ';

					if ( theFiles[0].files.length > maxfiles ) {
						result = "' . sprintf( __( 'Too many files selected, only %d allowed', 'wp-photo-album-plus' ), ini_get( 'max_file_uploads' ) ) . '";
						ok = false;
					}

					else while ( i<theFiles[0].files.length ) {
						if ( theFiles[0].files[i].size > maxlen ) {
							result += theFiles[0].files[i].name+" <span style=\'color:red\'>' . __( 'is too big', 'wp-photo-album-plus' ) . '</span><br>";
							ok = false;
						}
						else {
							result += theFiles[0].files[i].name+"<br>";
						}
						i++;
					}

					jQuery("#"+id+"-display").val(result);
					jQuery("#"+id+"-display").html(result);
					if ( ! ok ) {
						jQuery( "#wppa-submit" ).css( "display", "none" );
					}

					return ok;
				}';
			}
			break;

		case '_wppa_page_import':
			{
				$the_js = '
				function wppaVfyAlbum() {
					var csvs = jQuery( ".wppa-csv" );
					if ( ! jQuery( "#wppa-update" ).prop( "checked" ) ) {
						if ( 	! parseInt( jQuery( "#wppa-photo-album" ).val() ) &&
								! parseInt( jQuery( "#wppa-video-album" ).val() ) &&
								! parseInt( jQuery( "#wppa-audio-album" ).val() ) &&
								! parseInt( jQuery( "#wppa-document-album" ).val() ) &&
								csvs.length == 0
							) {
							alert( "Please select an album first" );
							return false;
						}
					}
					return true;
				}
				function wppaCheckInputVars() {
					var checks = jQuery( ":checked" );
					var nChecks = checks.length;
					var nMax = ' . ini_get( "max_input_vars" ) . ';
					if ( nMax == 0 ) nMax = 100;
					if ( nChecks > nMax ) {
						alert ( "There are "+nChecks+" boxes checked or selected, that is more than the maximum allowed number of "+nMax );
						return false;
					}
					var dirs = jQuery( ".wppa-dir" );
					var nDirsChecked = 0;
					if ( dirs.length > 0 ) {
						var i = 0;
						while ( i < dirs.length ) {
							if ( jQuery( dirs[i] ).prop( "checked" ) ) {
								nDirsChecked++;
							}
							i++;
						}
					}
					var zips = jQuery( ".wppa-zip" );
					var nZipsChecked = 0;
					if ( zips.length > 0 ) {
						var i = 0;
						while ( i < zips.length ) {
							if ( jQuery( zips[i] ).prop( "checked" ) ) {
								nZipsChecked++;
							}
							i++;
						}
					}
					// If no dirs to import checked, there must be an album selected
					if ( 0 == nDirsChecked && 0 == nZipsChecked && ! wppaVfyAlbum() ) return false;
					return true;
				}

				var wppaImportRuns = false;
				var wppaTimer;
				function wppaDoAjaxImport() {
					jQuery( "#wppa-spinner" ).css( "display", "none" );

					var data = "";
					data += "wppa-update-check="+jQuery( "#wppa-update-check" ).val();
					data += "&wppa-photo-album="+jQuery( "#wppa-photo-album" ).val();
					data += "&wppa-video-album="+jQuery( "#wppa-video-album" ).val();
					data += "&wppa-audio-album="+jQuery( "#wppa-audio-album" ).val();
					data += "&wppa-document-album="+jQuery( "#wppa-document-album" ).val();
					data += "&wppa-watermark-file="+jQuery( "#wppa-watermark-file" ).val();
					data += "&wppa-watermark-pos="+jQuery( "#wppa-watermark-pos" ).val();
					if ( jQuery( "#cre-album" ).prop( "checked" ) ) data += "&cre-album="+jQuery( "#cre-album" ).val();
					if ( jQuery( "#use-backup" ).prop( "checked" ) ) data += "&use-backup=1";
					if ( jQuery( "#wppa-update" ).prop( "checked" ) ) data += "&wppa-update=1";
					if ( jQuery( "#wppa-nodups" ).prop( "checked" ) ) data += "&wppa-nodups=1";
					if ( jQuery( "#del-after-p" ).prop( "checked" ) ) data += "&del-after-p=1";
					if ( jQuery( "#del-after-f" ).prop( "checked" ) ) data += "&del-after-f=1";
					if ( jQuery( "#del-after-v" ).prop( "checked" ) ) data += "&del-after-v=1";
					if ( jQuery( "#del-after-u" ).prop( "checked" ) ) data += "&del-after-u=1";
					if ( jQuery( "#del-after-d" ).prop( "checked" ) ) data += "&del-after-d=1";
					data += "&wppa-import-submit=ajax";

					var files = jQuery( ":checked" );
					var found = false;
					var i=0;
					var elm;
					var fulldata;
					for ( i=0; i<files.length; i++ ) {
						found = false;	// assume done
						elm = files[i];
						// Is it a file checkbox?
						var temp = elm.id.split( "-" );
						if ( temp[0] != "file" ) continue;	// no
						fulldata = data+"&import-ajax-file="+elm.title;
						found = true;
						break;
					}
					//	alert( data );
					if ( ! found ) {
						wppaStopAjaxImport();
						return;	// nothing left
					}
					// found one, do it
					var oldhtml=jQuery( "#name-"+elm.id ).html();
					var xmlhttp = wppaGetXmlHttp();
					xmlhttp.onreadystatechange = function() {
						if ( xmlhttp.readyState == 4 ) {
							if ( xmlhttp.status!=404 ) {
								var resp = xmlhttp.responseText;

								//
								if ( resp.length == 0 ) {
									jQuery( "#name-"+elm.id ).html("<span style=\'color:red\'>Timeout</span>" );
									wppaStopAjaxImport();
									return;
								}
								//
								if ( resp.indexOf( "Server" ) != -1 && resp.indexOf( "Error" ) != -1 ) {
									resp = "<span style=\'color:red\'>Server error</span>";
								}
								jQuery( "#name-"+elm.id ).html( "&nbsp;&nbsp;<b>"+resp+"</b>" );
								elm.checked = "";
								if ( jQuery( "#del-after-p" ).prop( "checked" ) ||
									 jQuery( "#del-after-f" ).prop( "checked" ) ) {
									elm.disabled = "disabled";
									elm.title = "";
								}
								if ( wppaImportRuns ) {
									wppaTimer = setTimeout( "wppaDoAjaxImport()", jQuery( "#wppa-delay" ).val() );	// was 100
									jQuery( "#wppa-spinner" ).css( "display", "inline" );
								}
							}
							else {
								jQuery( "#name-"+elm.id ).html( "&nbsp;&nbsp;<b>Not found</b>" );
							}
						}
					}
					var url = wppaAjaxUrl+"?action=wppa&wppa-action=import";
					xmlhttp.open( "POST",url,true );
					xmlhttp.setRequestHeader( "Content-type","application/x-www-form-urlencoded" );
					xmlhttp.send( fulldata );
					jQuery( "#name-"+elm.id ).html( "&nbsp;&nbsp;<b style=\'color:blue\' >" + "' . __( "Working...", "wp-photo-album-plus" ) . '" + "</b>" );
					if ( wppaImportRuns ) {
						jQuery( "#wppa-start-ajax" ).css( "display", "none" );
						jQuery( "#wppa-stop-ajax" ).css( "display", "inline" );
					}
				}
				function wppaStopAjaxImport() {
					wppaImportRuns = false;
					clearTimeout( wppaTimer );
					jQuery( "#wppa-start-ajax" ).css( "display", "inline" );
					jQuery( "#wppa-stop-ajax" ).css( "display", "none" );
					jQuery( "#wppa-spinner" ).css( "display", "none" );
				}';

				wppa_add_inline_script( 'wppa-admin', $the_js, true );

			}
			break;
		default:

			wppa_log( 'err', "No local js for $slug in wppa_add_local_js()" );
			return;
			break;
	}

	wppa_add_inline_script( 'wppa-admin', $the_js, true );
}